/* Scrivere un programma C per il calcolo della deviazione standard, voto
massimo e voto minimo dei voti conseguiti da una classe di 20 studenti.
I dati di input (interi) devono essere caricati da file. */

/* Deviaz. standard = [(Somma((Xi-Xm)^2))/N]^1/2 */

#include <stdio.h>
#include <math.h>

void riscrivi(int *vettore);

main()
{   const int N=20;
	float average, somma_scarti=0, deviazione_std;
	int i, counter, grade[N], total, massimo, minimo;
	char votoletto[5];
	FILE *sorgente;
	
    /* inizializzazione delle variabili */
	total=0;
	counter=0;
	/* Apertura file */
    if ((sorgente=fopen("voti.txt","r"))==NULL)
      printf("\nImpossibile aprire in lettura il file.\n");
    else
  	  while ((counter<N)&&(!feof(sorgente)))
  	  {	counter++;
  	    fscanf(sorgente,"%s",votoletto);
  	    /* fgets(votoletto,5,sorgente); */
  	    grade[counter-1]=atoi(votoletto);
		printf("Voto %02d letto da file: %d\n",counter,grade[counter-1]);
		if (counter==1)
		  massimo=minimo=grade[counter-1];
		else
		  if (grade[counter-1]<minimo)
		      minimo=grade[counter-1];
	        else if (grade[counter-1]>massimo)
	          massimo=grade[counter-1];
		total=total+grade[counter-1];
	  };
	average=(float) total/counter;
	/* Calcolo della deviazione standard */
	for (i=0;i<N;i++)
	  somma_scarti+=pow(grade[i]-average,2);
    deviazione_std=sqrt(somma_scarti/N);
    fclose(sorgente); /* Chiusura file */
	printf("\n\nLa deviazione standard dei voti nella classe e\' pari a: %.2f", deviazione_std);
	printf("\nIl voto piu\' basso e\': %d", minimo);
	printf("\nIl voto piu\' alto e\': %d\n\n", massimo);
		riscrivi(grade);
	getch();

	return 0;	/* Terminaz. del programma con successo*/
}

/* Procedura per la scrittura dei valori letti su un file */
void riscrivi(int *vettore)
{ FILE *destinazione;
  int i;
  if ((destinazione=fopen("votinum.txt","w"))==NULL)
    printf("\nImpossibile scrivere sul file di destinazione.\n");
  else
    for (i=0;i<20;i++)
      fprintf(destinazione,"%d\n",vettore[i]);
      /*fwrite(&vettore[i],sizeof(int),1,destinazione);*/
  
  fclose(destinazione);
}
